﻿
Imports System.Data
Imports System.IO
Imports Telerik.Web.Spreadsheet
Imports Telerik.Web.UI
Imports Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx

Partial Class Export_RadGrid_Export_Two_Grids_To_Excel
    Inherits System.Web.UI.Page
    Public Property ExportOutput1 As String
        Get
            If Session("ExportOutput1") Is Nothing Then
                Session("ExportOutput1") = String.Empty
            End If

            Return Session("ExportOutput1").ToString()
        End Get
        Set(ByVal value As String)
            Session("ExportOutput1") = value
        End Set
    End Property

    Public Property ExportingInProgress As Boolean
        Get
            Dim expInProgress As Boolean? = DirectCast(Session("ExportingInProgress"), Boolean?)
            If (expInProgress <> True) Then
                Return False
            Else
                Return True
            End If
            'If (TryCast(a, Boolean)) Is Nothing Then
            'End If
            'Return If(TryCast(Session("ExportingInProgress"), Nullable(Of Boolean)), False)
        End Get
        Set(ByVal value As Boolean)
            Session("ExportingInProgress") = value
        End Set
    End Property

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
    End Sub

    Protected Sub RadGrid1_NeedDataSource(ByVal sender As Object, ByVal e As GridNeedDataSourceEventArgs)
        RadGrid1.DataSource = GetGridSource()
    End Sub

    Protected Sub RadGrid2_NeedDataSource(ByVal sender As Object, ByVal e As GridNeedDataSourceEventArgs)
        RadGrid2.DataSource = GetGridSource()
    End Sub

    Private Function GetGridSource() As DataTable
        Dim dataTable As DataTable = New DataTable()
        Dim column As DataColumn = New DataColumn()
        column.DataType = Type.[GetType]("System.Int32")
        column.ColumnName = "OrderID"
        dataTable.Columns.Add(column)
        column = New DataColumn()
        column.DataType = Type.[GetType]("System.DateTime")
        column.ColumnName = "OrderDate"
        dataTable.Columns.Add(column)
        column = New DataColumn()
        column.DataType = Type.[GetType]("System.Decimal")
        column.ColumnName = "Freight"
        dataTable.Columns.Add(column)
        column = New DataColumn()
        column.DataType = Type.[GetType]("System.String")
        column.ColumnName = "ShipName"
        dataTable.Columns.Add(column)
        column = New DataColumn()
        column.DataType = Type.[GetType]("System.String")
        column.ColumnName = "ShipCountry"
        dataTable.Columns.Add(column)
        Dim PrimaryKeyColumns As DataColumn() = New DataColumn(0) {}
        PrimaryKeyColumns(0) = dataTable.Columns("OrderID")
        dataTable.PrimaryKey = PrimaryKeyColumns

        For i As Integer = 0 To 80
            Dim row As DataRow = dataTable.NewRow()
            row("OrderID") = i + 1
            row("OrderDate") = DateTime.Now
            row("Freight") = (i + 1) + (i + 1) * 0.1 + (i + 1) * 0.01
            row("ShipName") = "Name " & (i + 1)
            row("ShipCountry") = "Country " & (i + 1)
            dataTable.Rows.Add(row)
        Next

        Return dataTable
    End Function

    Protected Sub RadGrid1_GridExporting(ByVal sender As Object, ByVal e As GridExportingArgs)
        If e.ExportType = ExportType.ExcelXlsx Then
            ExportOutput1 = e.ExportOutput
            ExportingInProgress = True
            Response.Redirect(Request.RawUrl)
        End If
    End Sub

    Protected Sub RadGrid2_GridExporting(ByVal sender As Object, ByVal e As GridExportingArgs)
        If e.ExportType = ExportType.ExcelXlsx Then
            Dim xlsxProvider As XlsxFormatProvider = New XlsxFormatProvider()
            Dim exportOutput2 As String = e.ExportOutput
            Dim workBookGrid2 As Telerik.Windows.Documents.Spreadsheet.Model.Workbook = xlsxProvider.Import(Encoding.[Default].GetBytes(exportOutput2))
            Dim workBookGrid1 As Telerik.Windows.Documents.Spreadsheet.Model.Workbook = xlsxProvider.Import(Encoding.[Default].GetBytes(ExportOutput1))
            workBookGrid2.Worksheets.Add().CopyFrom(workBookGrid1.Worksheets(0))

            Dim data As Byte() = Nothing

            Using ms As New MemoryStream()
                xlsxProvider.Export(workBookGrid2, ms)
                data = ms.ToArray()
            End Using

            ExportOutput1 = ""
            ExportingInProgress = False
            Response.ContentType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
            Response.Headers.Remove("Content-Disposition")
            Response.AppendHeader("Content-Disposition", "attachment; filename=" & RadGrid1.ExportSettings.FileName & ".xlsx")
            Response.BinaryWrite(data)
            Response.[End]()
        End If
    End Sub

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs)
        RadGrid1.ExportToExcel()
    End Sub
End Class

